#include <iostream>
#include <fstream>
#include <string>
#include <vector>
#include <set>
#include <map>
#include <algorithm>
#include <deque>
#include <queue>
#include <iomanip>
#include <cstdlib>

using namespace std;
typedef long long ll;
const int INF = 1e9;
ll sum, n, m;
vector<int> bfs(vector<vector<int>> gr, int start) {
	vector<int> dist(gr.size(), INF);
	queue<int> q; q.push(start);

	dist[start] = 0;
	while (q.size()) {
		int now = q.front(); q.pop();
		for (auto to : gr[now]) {
			if (dist[to] > dist[now] + 1) {
				dist[to] = dist[now] + 1;
				q.push(to);
			}
		}
	}
	dist.pop_back();
	return dist;
}
int main() {
	ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
#ifdef _DEBUG
	fstream cin("input.txt");
	ofstream cout("output.txt");
#endif // _DEBUG

	int n, k, t; cin >> n >> k >> t;
	vector<vector<int>> gr(n + 1);
	for (int i = 0; i < n - 1; i++) {
		int start, finish; cin >> start >> finish;
		gr[start].push_back(finish);
		gr[finish].push_back(start);
	}
	if (t == 0) {
		vector<int> ans = bfs(gr, 1);
		sort(ans.begin(), ans.end());
		if (k >= n - 1)cout << 1 << " ";
		else cout << ans[ans.size() - k - 1]<<" ";
	}
	else if (t == 1) {
		for (int i = 1; i <= n; i++) {
			vector<int> ans = bfs(gr, i);
			sort(ans.begin(), ans.end());
			if (k >= n - 1)cout << 1 << " ";
			else cout << ans[ans.size() - k - 1]<<" ";
		}
	}





}



